
In this poster, we plan to tackle each of the questions
listed above by highlighting the key takeaways from the
sites' responses. We present an overview below. For
brevity, in this extended abstract, we focus more on
the responses, and less on mapping them to the names of
the actual sites.


\subsection{Motivation for the sites}

One of the major concerns observed among the sites, was
the anticipation of inevitable shortage of power and
energy available for running future systems.  Another
strong motivation has been the enforcement of hard
upper limits on power consumption, set by contractual
agreements between the site management and funding
sources.

Some supercomputing centers are facing the challenge of
limited power and cooling capacity available on-site.
The potential for significant cost-savings associated
with higher energy efficiency is another strong
motivation.  Other sites are pursuing the goal of
``being green" and ecologically responsible by
investing in such JSRM techniques. For some sites,
achieving a low PUE target is the primary goal behind
their investments in energy and power-aware techniques.
Another interesting motivation for JSRM is to ration
the availability of cooling infrastructure so that the
thermal capacity can be directed from workloads with
low-demand towards those with higher power-signatures.

\subsection{JSRM solutions adopted by the sites}

When it comes to adopting JSRM approaches within
supercomputing centers, two different focus areas arise
-  monitoring and management of energy/power based
metrics.


\begin{itemize}
	\item \underline{Monitoring:}
	      \begin{itemize} 
		      \item There have been efforts to
			      measure energy/power 
			      continuously, both
			      in-band as well as
			      out-of-band.
      
		      \item While some centers rely on
			      sensors that make direct
			      real-time  measurements
			      of energy/power consumed,
			      others use thermal-based
			      sensors together with a
			      model to indirectly
			      derive power and energy
			      metrics.

		      \item Some centers are working on
			      exposing high-level APIs
			      and feedback mechanisms
			      to enable end-users and
			      resource managers to
			      monitor the power
			      consumed by various
			      system components. The
			      goal is to provide an
			      interface that can be
			      used by future JSRM
			      solutions for making
			      informed decisions while
			      allocating power budgets.

		      \item Some sites have also been
			      investing in implementing
			      statistical approaches
			      for predicting
			      energy/power demands of a
			      give job based on its
			      user-id, resource
			      request, job-size, and
			      job-length. Such cases
			      are useful for sites
			      where energy/power
			      requirements by the
			      applications can be
			      mapped to specific users
			      submitting the jobs.

	      \end{itemize}

        \item \underline{Power Management:}

	      \begin{itemize}
		    \item One notable approach being
			    adopted by supercomputing
			    sites is dynamically
			    shutting down jobs as a
			    response to system power
			    reaching the total budget.
			    The decision on what
			    specific jobs to shut down
			    depends on a number of
			    factors like the job-size,
			    application power,
			    job-length, etc. This is a
			    reactive approach.

	            \item A proactive solution to the
			    budget overflow problem is
			    to configure the resource
			    manager to reduce the
			    number of nodes available
			    for job allocation. This
			    approach reduces the
			    theoretical maximum power
			    that can be consumed by the
			    system, but at the cost of
			    reducing system
			    utilization.

	           \item  Another notable approach
			   being adopted is leveraging
			   power-capping mechanisms
			   supported by CPU and system
			   vendors to ensure that the
			   total budget remains below a
			   specific limit. This
			   hardware enforced limit is
			   usually applied over a
			   specific time-window (in the
			   order of minutes). 

		   \item An alternative approach to
			   using power-capping is
			   triggering the system processing
			   units to operating at
			   specific operating
			   frequencies (hardware
			   p-states). Some
			   sites are working on
			   designing portable APIs to enable
			   users and system admins to
			   list the actual value of the
			   frequencies. 

		   \item It has been observed that
			   there is very little
			   `intuition' among end users
			   when it comes to mapping
			   application behavior to
			   specific p-states. And so,
			   many sites are working
			   towards system-wide
			   frameworks (job schedulers,
			   resource maangers, etc.)
			   that attempt at using static
			   prediction models to map
			   applications to their ideal
			   p-states.  While this
			   approach gives promising
			   power efficiency metrics,
			   the variation in application
			   performance during repeated
			   runs is being investigated.

		   \item One feedback-driven approach
			   being explored is ``tagging"
			   applications based on their
			   power efficiency attained
			   over past job runs. It is
			   expected that these ``tags"
			   will then be used by future
			   resource managers while
			   allocating resources during
			   future job requests. This
			   directly addresses the
			   challenge in having the job
			   scheduler be responsible to
			   identify and maintain a
			   historical record of unique
			   set of job characteristics.

	      \end{itemize}
\end{itemize}	


%  Items not included due to lack of information on
%  implementation details:
%  - IBM's propritary LSF (EAS) scheduler  in LRZ
%  - Trinity's in-progress research on *adaptive* power
%    monitoring in collaboration w/ Cray
